<script setup lang="ts">
import { RouterLink, RouterView, useRoute, useRouter } from 'vue-router'
import { ref, onMounted } from 'vue'
import { useAuthStore } from '@/stores/auth'

const router = useRouter()
const route = useRoute()

const authStore = useAuthStore()

const roleStatusManager = ref(false)
const roleStatusStaff = ref(false)
const roleStatusOwner = ref(false)

onMounted(() => {
  const strUser = localStorage.getItem('user')

  try {
    if (strUser) {
      const parsedUser = JSON.parse(strUser)
      const nowRole = parsedUser.role

      if (nowRole === 'Manager') {
        roleStatusManager.value = true
        roleStatusStaff.value = false
        roleStatusOwner.value = false
      } else if (nowRole === 'Staff') {
        roleStatusManager.value = false
        roleStatusOwner.value = false
        roleStatusStaff.value = true
      } else if (nowRole === 'Owner') {
        roleStatusManager.value = false
        roleStatusStaff.value = false
        roleStatusOwner.value = true
      }
    }
  } catch (error) {
    console.error('Error parsing user data:', error)
  }
})
</script>

<template>
  <div>
    <v-navigation-drawer
      v-model="roleStatusManager"
      expand-on-hover
      rail
      :width="300"
      color="grey-darken-4"
      permanent
    >
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-home"
        link
        title="Main Menu"
        rounded
        :class="{ active: route.name === 'mainmenu' }"
        :to="{ path: '/MainMenu' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-coffee-maker"
        link
        title="POS"
        rounded
        :class="{ active: route.name === 'pos' }"
        :to="{ path: '/POS' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-account-group-outline"
        link
        title="Employee"
        rounded
        :class="{ active: route.name === 'employee' }"
        :to="{ path: '/Employee' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-account-multiple"
        link
        title="Member"
        rounded
        :class="{ active: route.name === 'member' }"
        :to="{ path: '/Member' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-coffee"
        link
        title="Product"
        rounded
        :class="{ active: route.name === 'product' }"
        :to="{ path: '/Product' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-archive"
        link
        rail
        title="Stock"
        rounded
        :class="{ active: route.name === 'stock' }"
        :to="{ path: '/Stock' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-file"
        link
        title="Bill Cost"
        rounded
        :class="{ active: route.name === 'billcost' }"
        :to="{ path: '/BillCost' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-checkbox-multiple-outline"
        link
        title="CheckIn CheckOut"
        rounded
        :class="{ active: route.name === 'checkin' }"
        :to="{ path: '/CheckIn' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-currency-usd"
        link
        title="Salary"
        rounded
        :class="{ active: route.name === 'salary' }"
        :to="{ path: '/Salary' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-receipt-text"
        link
        title="Receipt"
        rounded
        :class="{ active: route.name === 'receipt' }"
        :to="{ path: '/Receipt' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-gift-outline"
        link
        title="Promotion"
        rounded
        :class="{ active: route.name === 'promotion' }"
        :to="{ path: '/Promotion' }"
        class="list-item-hover"
      ></v-list-item>
      <!-- <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-tournament"
        link
        title="Report"
        rounded
        :class="{ active: route.name === 'report' }"
        :to="{ path: '/Report' }"
        class="list-item-hover"
      ></v-list-item> -->
      <!-- <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-tournament"
        link
        title="ReportUser"
        rounded
        :class="{ active: route.name === 'reportUser' }"
        :to="{ path: '/ReportUser' }"
        class="list-item-hover"
      ></v-list-item> -->

      <template v-slot:append>
        <div class="pa-1">
          <v-list-item
            active-color="deep-orange-darken-4"
            prepend-icon="mdi-tune"
            link
            title="Setting"
            rounded
            :class="{ active: route.name === 'setting' }"
            :to="{ path: '/Setting' }"
            class="list-item-hover"
          ></v-list-item>
          <v-list-item
            active-color="deep-orange-darken-4"
            prepend-icon="mdi-exit-to-app"
            link
            title="Logout"
            rounded
            @click="authStore.logout()"
            :class="{ active: route.name === 'home' }"
            :to="{ path: '/' }"
            class="list-item-hover"
          ></v-list-item>
        </div>
      </template>
    </v-navigation-drawer>

    <v-navigation-drawer
      v-model="roleStatusStaff"
      expand-on-hover
      rail
      :width="300"
      color="grey-darken-4"
      permanent
    >
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-home"
        link
        title="Main Menu"
        rounded
        :class="{ active: route.name === 'mainmenu' }"
        :to="{ path: '/MainMenu' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-coffee-maker"
        link
        title="POS"
        rounded
        :class="{ active: route.name === 'pos' }"
        :to="{ path: '/POS' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-account-multiple"
        link
        title="Member"
        rounded
        :class="{ active: route.name === 'member' }"
        :to="{ path: '/Member' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-coffee"
        link
        title="Product"
        rounded
        :class="{ active: route.name === 'product' }"
        :to="{ path: '/Product' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-archive"
        link
        title="Stock"
        rounded
        :class="{ active: route.name === 'stock' }"
        :to="{ path: '/Stock' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-file"
        link
        title="Bill Cost"
        rounded
        :class="{ active: route.name === 'billcost' }"
        :to="{ path: '/BillCost' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-checkbox-multiple-outline"
        link
        title="CheckIn CheckOut"
        rounded
        :class="{ active: route.name === 'checkin' }"
        :to="{ path: '/CheckIn' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-receipt-text"
        link
        title="Receipt"
        rounded
        :class="{ active: route.name === 'receipt' }"
        :to="{ path: '/Receipt' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-gift-outline"
        link
        title="Promotion"
        rounded
        :class="{ active: route.name === 'promotion' }"
        :to="{ path: '/Promotion' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-currency-usd"
        link
        title="Salary"
        rounded
        :class="{ active: route.name === 'salary' }"
        :to="{ path: '/Salary' }"
        class="list-item-hover"
      ></v-list-item>

      <template v-slot:append>
        <div class="pa-1">
          <v-list-item
            active-color="deep-orange-darken-4"
            prepend-icon="mdi-tune"
            link
            title="Setting"
            rounded
            :class="{ active: route.name === 'setting' }"
            :to="{ path: '/Setting' }"
            class="list-item-hover"
          ></v-list-item>
          <v-list-item
            active-color="deep-orange-darken-4"
            prepend-icon="mdi-exit-to-app"
            link
            title="Logout"
            rounded
            @click="authStore.logout()"
            :class="{ active: route.name === 'home' }"
            :to="{ path: '/' }"
            class="list-item-hover"
          ></v-list-item>
        </div>
      </template>
    </v-navigation-drawer>

    <v-navigation-drawer
      v-model="roleStatusOwner"
      expand-on-hover
      rail
      :width="300"
      color="grey-darken-4"
      permanent
    >
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-home"
        link
        title="Main Menu"
        rounded
        :class="{ active: route.name === 'mainmenu' }"
        :to="{ path: '/MainMenu' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-coffee-maker"
        link
        title="POS"
        rounded
        :class="{ active: route.name === 'pos' }"
        :to="{ path: '/POS' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-account-group-outline"
        link
        title="Employee"
        rounded
        :class="{ active: route.name === 'employee' }"
        :to="{ path: '/Employee' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-account-multiple"
        link
        title="Member"
        rounded
        :class="{ active: route.name === 'member' }"
        :to="{ path: '/Member' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-coffee"
        link
        title="Product"
        rounded
        :class="{ active: route.name === 'product' }"
        :to="{ path: '/Product' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-archive"
        link
        rail
        title="Stock"
        rounded
        :class="{ active: route.name === 'stock' }"
        :to="{ path: '/Stock' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-file"
        link
        title="Bill Cost"
        rounded
        :class="{ active: route.name === 'billcost' }"
        :to="{ path: '/BillCost' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-checkbox-multiple-outline"
        link
        title="CheckIn CheckOut"
        rounded
        :class="{ active: route.name === 'checkin' }"
        :to="{ path: '/CheckIn' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-currency-usd"
        link
        title="Salary"
        rounded
        :class="{ active: route.name === 'salary' }"
        :to="{ path: '/Salary' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-receipt-text"
        link
        title="Receipt"
        rounded
        :class="{ active: route.name === 'receipt' }"
        :to="{ path: '/Receipt' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-gift-outline"
        link
        title="Promotion"
        rounded
        :class="{ active: route.name === 'promotion' }"
        :to="{ path: '/Promotion' }"
        class="list-item-hover"
      ></v-list-item>
      <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-tournament"
        link
        title="Branch"
        rounded
        :class="{ active: route.name === 'branch' }"
        :to="{ path: '/Branch' }"
        class="list-item-hover"
      ></v-list-item>
      <!-- <v-list-item
        active-color="deep-orange-darken-4"
        prepend-icon="mdi-tournament"
        link
        title="Report"
        rounded
        :class="{ active: route.name === 'report' }"
        :to="{ path: '/Report' }"
        class="list-item-hover"
      ></v-list-item> -->

      <template v-slot:append>
        <div class="pa-1">
          <v-list-item
            active-color="deep-orange-darken-4"
            prepend-icon="mdi-tune"
            link
            title="Setting"
            rounded
            :class="{ active: route.name === 'setting' }"
            :to="{ path: '/Setting' }"
            class="list-item-hover"
          ></v-list-item>
          <v-list-item
            active-color="deep-orange-darken-4"
            prepend-icon="mdi-exit-to-app"
            link
            title="Logout"
            rounded
            @click="authStore.logout()"
            :class="{ active: route.name === 'home' }"
            :to="{ path: '/' }"
            class="list-item-hover"
          ></v-list-item>
        </div>
      </template>
    </v-navigation-drawer>
  </div>
</template>

<style scoped>
.list-item-hover {
  transition:
    transform 0.2s ease,
    box-shadow 0.2s ease; /* Add transitions for smoother animation */
}

.list-item-hover:hover {
  transform: scale(1.05); /* Increase size by 5% on hover */
  box-shadow:
    0 4px 6px rgba(0, 0, 0, 0.1),
    0 1px 3px rgba(0, 0, 0, 0.08); /* Add a subtle box shadow */
}
</style>
